/*                                                           Pontificia Universidade Catolica
 *  Campinas - Sao Paulo - Brasil
 *  dez/2004
 *
 * 	Projeto Semestral - Sistemas Operacionais 2
 *
 *	Camada Independente de Dispositivos : DRIVER 
 * 
 *	Desenvolvedor:  	Cesar Kallas		:RA 02099224	cesarkallas@gmx.net
 *
 *	Estruturas e dados usados na fila de mensagem com o driver e a cid
 *	por a cid e o driver usarem, estao em arquivos separados
* Ultima atualizacao: 09/12/2004
*/


// Includes necessarios para o driver e para a cid
#include <stdio.h>				// printf(), file, ...
#include <stdlib.h>
#include <sys/ipc.h>            // Todas as funcoes de IPC
#include <sys/msg.h>			// msgget(), msgsnd(), msgrcv()
#include <sys/shm.h>            // shmget(), shmat()
#include <sys/sem.h>            // semget(), semop()
#include <pthread.h>			// pthread()

// Define se eh para imprimir ou nao no terminal o que esta acontecendo
#define PRINT
#define MSG_CID					0x2100	/* Chave da Fila de Mensagens da Camada Independete de Dispositivo com o DRIVER */
#define TAM_NOME_ARQUIVO		8
#define TAM_MAX_URL	150

int msg_cid;		/* Identificacao da Fila de mensagem que ira comunicar com o Driver */
int shm_buffer;
int shm_bfd;

key_t SHM_BFD		= 0x6250;
key_t SHM_BUFFER	= 0x6120;

/* Estrutura de uma requisicao passada ao driver */
typedef struct
{
	int operacao;		// Tipo da operacao: LEITURA; ESCRITA; LEITURA E ESCRITA
//	int tamanho;		// Tamanho em bytes que serao manipulados na requisicao de read/write
	int index;
	int id_share_bloco;	// numero que indentifica o bloco compartilhado para ser armazenado os dados pedidos
	int pid;			// PID do processo que requisitou a operacao
} REQUISICAO;

/* Buffer da mensagem que fizer a requisicao: aonde sera armazenado os dados lidos */
typedef struct
{
	long mtype;				/* tipo da mensagem */
	char mtext[sizeof(REQUISICAO)];		/* conteudo da mensagem, ou seja, a struct REQUISICAO */
} BUFFER_REQUISICAO;

typedef struct
{
	int status;
} RESPOSTA;

/* Buffer da mensagem que fizer a requisicao: aonde sera armazenado o RESULTADO da requisicao */
typedef struct
{
	long mtype;
	char mtext[sizeof(RESPOSTA)];
} BUFFER_RESPOSTA;

typedef struct
{
	int index;
	char tipo;
	char nome[TAM_NOME_ARQUIVO*5];
} BUFFER;
BUFFER *buffer;

typedef struct
{
	int index;
	int tipo;
	int primeiro_bloco;
} BFD;
BFD *bfd;

// Declara as estruturas usadas para a comunicao com o driver
// Sao usadas no [driver.c:driver] e [cid.h:ffopen]

// Estrtura de requisicao embutida na fila de mensagens
BUFFER_REQUISICAO buffer_requisicao;
REQUISICAO *requisicao = (REQUISICAO *)(buffer_requisicao.mtext);


// Estrtura de resposta embutida na fila de mensagens
BUFFER_RESPOSTA buffer_resposta;
RESPOSTA *resposta = (RESPOSTA *)(buffer_resposta.mtext);


int print(char *string)
{
	#ifdef PRINT
		fflush(stderr);
		fflush(stdout);
			fprintf(stdout, string);
			fprintf(stdout, "\n");
		fflush(stderr);
		fflush(stdout);
	#endif
}

int prints(char *string)
{
	#ifdef PRINT
		fflush(stderr);
		fflush(stdout);
			printf("%s", string);
		fflush(stderr);
		fflush(stdout);
	#endif
}

int printi(int numero)
{
	#ifdef PRINT
		fflush(stderr);
		fflush(stdout);
			printf("%i", numero);
		fflush(stderr);
		fflush(stdout);
	#endif
}
